searchNodes=[{"ref":"Webuntis.html","title":"Webuntis","type":"module","doc":"Documentation for Webuntis."},{"ref":"Webuntis.html#absences/4","title":"Webuntis.absences/4","type":"function","doc":"List all absences for the given range. Returns Webuntis.Struct.Absence structs"},{"ref":"Webuntis.html#homework_student/3","title":"Webuntis.homework_student/3","type":"function","doc":"List all homework for the given range. Example: homework_student( 889, Date.utc_today(), Date.utc_today() |&gt; Date.add(7) )"},{"ref":"Webuntis.html#messages/1","title":"Webuntis.messages/1","type":"function","doc":"List the messages of the day."},{"ref":"Webuntis.html#timetable_class/3","title":"Webuntis.timetable_class/3","type":"function","doc":"This is the same as timetable_student but for classes."},{"ref":"Webuntis.html#timetable_student/3","title":"Webuntis.timetable_student/3","type":"function","doc":"Display the timetable for the given time. Example usage for today: timetable_student(889, Date.utc_today(), Date.utc_today())"},{"ref":"Webuntis.html#userdata/0","title":"Webuntis.userdata/0","type":"function","doc":"This returns a lot of data: master data (used internal to resolve elements) settings messenger settings &quot;real&quot; user data (e.g. student id, display name etc.)"},{"ref":"Webuntis.Auth.JsonAuth.html","title":"Webuntis.Auth.JsonAuth","type":"module","doc":"Authentication module to use the mobile endpoint of Webuntis"},{"ref":"Webuntis.Auth.JsonAuth.html#login/3","title":"Webuntis.Auth.JsonAuth.login/3","type":"function","doc":"Start the json auth agent to use methods which requires authentication. Use the information provided by https://mese.webuntis.com/WebUntis/api/profile/access or use the gui to display the QR-code."},{"ref":"Webuntis.Auth.JsonAuth.html#shared_secret/3","title":"Webuntis.Auth.JsonAuth.shared_secret/3","type":"function","doc":"Request the shared app secret of the given user. But you need the school-id (e.g. 2567800 for mcg-gehrden)"},{"ref":"Webuntis.Auth.Totp.html","title":"Webuntis.Auth.Totp","type":"module","doc":"Generate a Time-Based One-Time Password used from 2 factor authentication. Official specification: https://tools.ietf.org/html/rfc6238 Original file: https://github.com/jameslafa/totpex/blob/master/lib/totpex.ex"},{"ref":"Webuntis.Auth.Totp.html#generate_totp/2","title":"Webuntis.Auth.Totp.generate_totp/2","type":"function","doc":"Generate Time-Based One-Time Password. The default period used to calculate the moving factor is 30s"},{"ref":"Webuntis.Struct.Absence.html","title":"Webuntis.Struct.Absence","type":"module","doc":""},{"ref":"Webuntis.Struct.Absence.html#from_map/1","title":"Webuntis.Struct.Absence.from_map/1","type":"function","doc":""},{"ref":"Webuntis.Struct.Class.html","title":"Webuntis.Struct.Class","type":"module","doc":""},{"ref":"Webuntis.Struct.Class.html#from_map/1","title":"Webuntis.Struct.Class.from_map/1","type":"function","doc":""},{"ref":"Webuntis.Struct.Excuse.html","title":"Webuntis.Struct.Excuse","type":"module","doc":""},{"ref":"Webuntis.Struct.Excuse.html#from_map/1","title":"Webuntis.Struct.Excuse.from_map/1","type":"function","doc":""},{"ref":"Webuntis.Struct.Period.html","title":"Webuntis.Struct.Period","type":"module","doc":""},{"ref":"Webuntis.Struct.Period.html#cancelled?/1","title":"Webuntis.Struct.Period.cancelled?/1","type":"function","doc":""},{"ref":"Webuntis.Struct.Period.html#from_map/1","title":"Webuntis.Struct.Period.from_map/1","type":"function","doc":""},{"ref":"Webuntis.Struct.Period.html#regular?/1","title":"Webuntis.Struct.Period.regular?/1","type":"function","doc":""},{"ref":"Webuntis.Struct.Period.html#special?/1","title":"Webuntis.Struct.Period.special?/1","type":"function","doc":""},{"ref":"Webuntis.Struct.Room.html","title":"Webuntis.Struct.Room","type":"module","doc":""},{"ref":"Webuntis.Struct.Room.html#from_map/1","title":"Webuntis.Struct.Room.from_map/1","type":"function","doc":""},{"ref":"Webuntis.Struct.Subject.html","title":"Webuntis.Struct.Subject","type":"module","doc":""},{"ref":"Webuntis.Struct.Subject.html#from_map/1","title":"Webuntis.Struct.Subject.from_map/1","type":"function","doc":""},{"ref":"Webuntis.Struct.Teacher.html","title":"Webuntis.Struct.Teacher","type":"module","doc":""},{"ref":"Webuntis.Struct.Teacher.html#from_map/1","title":"Webuntis.Struct.Teacher.from_map/1","type":"function","doc":""},{"ref":"json-rpc.html","title":"JSON-RPC","type":"extras","doc":"JSON-RPC Webuntis is using a json-rpc endpoint implemented in Java (jsonrpc4j). This library is using the mobile.webuntis.com server with the 2017 methods to get more data like cancelled or irregular periods."},{"ref":"json-rpc.html#request","title":"JSON-RPC - Request","type":"extras","doc":"Inquiries should be structured as follows: body { &quot;id&quot;: 0, &quot;jsonrpc&quot;: &quot;2.0&quot;, &quot;method&quot;: &quot;yourMethod&quot;, &quot;params&quot;: [] } headers; this header is completely sufficient: Content-Type: application/json"},{"ref":"json-rpc.html#authentication","title":"JSON-RPC - Authentication","type":"extras","doc":"A user account is required for all inquiries, which makes it difficult to test this library correctly. I&#39;m adding this to every request (except the shared_secret method): { &quot;user&quot;: username, &quot;otp&quot;: generated one-time password, &quot;clientTime&quot;: system time in milliseconds } The api never saves your password but have to remember your shared app secret. You can get your school-id and secret at: https://mese.webuntis.com/WebUntis/index.do#/basic/profile?selectedTab=access. Just click on show QR-code to display your data."},{"ref":"json-rpc.html#methods","title":"JSON-RPC - Methods","type":"extras","doc":"Timetable getTimetable2017 id: student or class id (e.g. 889) type: STUDENT / CLASS startDate: begin of the time range (e.g. 2020-03-13) endDate: end of this range You can use Elixir&#39;s build in dates here or just type your date as string in the iso-standard as a string. Example for displaying the timetable of the student for the current day: today = Date.utc_today() Webuntis.timetable_student(889, today, today) Homework getHomeWork2017 id: student id type: STUDENT startDate: begin of the time range (e.g. 2020-03-13) endDate: end of this range Get all homework for the time range. I don&#39;t have structs for them yet... Messages getMessagesOfDay2017 date: date for the messages Returns the news and messages of the day. Same as homework, I don&#39;t have structs for them yet... Absences getStudentAbsences2017 startDate: begin of the time range (e.g. 2020-03-13) endDate: end of this range includeExcused: display excused absences? (boolean) includeUnExcused: display unexcused absences? Displays all absences of a studnet for a school year, for example. See Webuntis.Struct.Absence and Webuntis.Struct.Excuse for more informations about the fields. Userdata getUserData2017 No extra params This returns a lot of data: master data (used internal to resolve elements) settings messenger settings &quot;real&quot; user data (e.g. student id, display name etc.) Response The endpoint answers in this structure: { &quot;jsonrpc&quot;: &quot;2.0&quot;, &quot;id&quot;: &quot;&quot;, &quot;result&quot;: { result } } All Webuntis function in the main module are encoding this json data, put it into maps and usally into structs like Webuntis.Struct.Teacher or Webuntis.Struct.Period."}]